
MB_OPENMSX_BOOT_TIMEOUT ?= 25
MB_OPENMSX_MACHINE      ?= Philips_NMS_8250
MB_OPENMSX_JOYPORTA     ?=
MB_OPENMSX_JOYPORTB     ?=
MB_OPENMSX_SETTING      := $(PATH_MSXBUILD_REAL)/lib/openmsx/boot_settings.xml
MB_OPENMSX_EXTS         ?=
MB_OPENMSX_EXTRA_MEM    ?= -ext ram4mb
MB_OPENMSX_ARGS = \
  -setting $(MB_OPENMSX_SETTING) \
  -machine $(MB_OPENMSX_MACHINE) \
  -ext slotexpander -ext ide $(MB_OPENMSX_EXTRA_MEM) $(MB_OPENMSX_EXTS) \
  -script $(PATH_MSXBUILD_REAL)/lib/openmsx/boot_env.tcl \
  -script $(PATH_MSXBUILD_REAL)/lib/openmsx/boot_hdd.tcl \
  -script $(PATH_MSXBUILD_REAL)/lib/openmsx/fail_after.tcl \
  -script $(MB_MSXHUB_CACHE)/OMSXCTL/1.0-1/get/OMSXCTL/omsxctl.tcl

# TODO: add run flag to disable xml output like "-control stdio-boot-only"
ifeq ($(OS),Windows_NT)
	MB_OPENMSX_CMD = $(PATH_OPENMSX)/openmsx $(MB_OPENMSX_ARGS) -control stdio < $(PATH_MSXBUILD_REAL)/lib/openmsx/boot_stdio.xml
else
	MB_OPENMSX_CMD = $(PATH_OPENMSX)/openmsx $(MB_OPENMSX_ARGS) -control stdio < $(PATH_MSXBUILD_REAL)/lib/openmsx/boot_stdio.xml | sed -n -e 's/.*>\(.*\)<.*/\1/p' | tail -n+3
endif
define _mb_openmsx_run
	@echo === Running openMSX
	$(if $(wildcard $(MB_MSXHUB_CACHE)/OMSXCTL/1.0-1/get/OMSXCTL/omsxctl.tcl),,$(call _mb_msxhub_fetch_file,$(MB_MSXHUB_API)/OMSXCTL/1.0-1/get/OMSXCTL/omsxctl.tcl))
	FAIL_AFTER_BOOT=$(MB_OPENMSX_BOOT_TIMEOUT) \
	FAIL_AFTER_PATH=bin \
	BOOT_HDD_PATH="$(1)" \
	BOOT_HDD_IMAGE="$(1)/../dsk.img" \
	JOYPORTA=$(MB_OPENMSX_JOYPORTA) \
	JOYPORTB=$(MB_OPENMSX_JOYPORTB) \
	$(MB_OPENMSX_CMD)
endef

define _mb_openmsx_run_dos
	$(call mb_msxhub_file,$(1)/omsxctl.com,$(MB_MSXHUB_API)/OMSXCTL/1.0-1/get/OMSXCTL/omsxctl.com)
	$(call _mb_openmsx_run,$(1))
endef

# TODO: add msx1+allversions of dos to https://github.com/fr3nd/msxhub-packages/issues/18
#define mb_openmsx_dos1
#	$(call mb_msxhub_get_dos1,$(1))
#	$(call _mb_openmsx_run_dos,$(1))
#endef

define mb_openmsx_dos2
	$(call mb_msxhub_get_dos2,$(1))
	$(call _mb_openmsx_run_dos,$(1))
endef

define mb_openmsx_nextor
	$(call mb_msxhub_get_nextor,$(1))
	$(call _mb_openmsx_run_dos,$(1))
endef

define mb_openmsx_macro80
	$(call mb_msxhub_get_macro80,$(1))
	$(call mb_openmsx_dos2,$(1))
endef

