
TEST_AHELLO_M80   := $(PATH_BIN)/test/ahello-m80
BUILD_HELP        += \\n\\t* $(TEST_AHELLO_M80)/ahello.com\\n\\t* test-ahello-m80-run\\n\\t* test-ahello-m80-assert

$(TEST_AHELLO_M80):
	$(call mb_mkdir,$(TEST_AHELLO_M80))

$(TEST_AHELLO_M80)/%.mac: test/ahello-m80/%.mac | $(TEST_AHELLO_M80)
	$(call mb_unix2dos,$<,$@)

$(TEST_AHELLO_M80)/ahello.rel: $(TEST_AHELLO_M80)/ahello.mac
	$(call mb_autoexec_cmd,$(TEST_AHELLO_M80),m80 =ahello/Z)
	$(call mb_openmsx_macro80,$(TEST_AHELLO_M80))
	
$(TEST_AHELLO_M80)/ahello.hex: $(TEST_AHELLO_M80)/ahello.rel
	$(call mb_autoexec_cmd,$(TEST_AHELLO_M80),l80 ahello$(MB_COMMA)ahello/N/X/Y/E)
	$(call mb_openmsx_macro80,$(TEST_AHELLO_M80))

$(TEST_AHELLO_M80)/ahello.com: $(TEST_AHELLO_M80)/ahello.hex
	$(call mb_hex2com,$(TEST_AHELLO_M80)/ahello.hex,$(TEST_AHELLO_M80)/ahello.com)

.PHONY: test-ahello-m80-run
test-ahello-m80-run: $(TEST_AHELLO_M80)/ahello.com
	$(call mb_autoexec_open_gui,$(TEST_AHELLO_M80))
	$(call mb_openmsx_macro80,$(TEST_AHELLO_M80))

.PHONY: test-ahello-m80-assert
test-ahello-m80-assert: $(TEST_AHELLO_M80)/ahello.com
	$(call mb_delete,$(TEST_AHELLO_M80)/test.out)
	$(call mb_autoexec_cmd_test,$(TEST_AHELLO_M80),ahello > test.out)
	$(call mb_openmsx_macro80,$(TEST_AHELLO_M80))
	grep "M80: Hello world..." $(TEST_AHELLO_M80)/test.out
