
TEST_AHELLO_SDCC  := $(PATH_BIN)/test/ahello-sdcc
BUILD_HELP        += \\n\\t* $(TEST_AHELLO_SDCC)/ahello.com\\n\\t* test-ahello-sdcc-run\\n\\t* test-ahello-sdcc-assert

$(TEST_AHELLO_SDCC):
	$(call mb_mkdir,$(TEST_AHELLO_SDCC))

$(TEST_AHELLO_SDCC)/%.rel: test/ahello-sdcc/%.asm | $(TEST_AHELLO_SDCC)
	$(call mb_compile_asm,$@,$<)

$(TEST_AHELLO_SDCC)/ahello.hex: $(TEST_AHELLO_SDCC)/ahello.rel
	$(call mb_link_asm_dos,$(TEST_AHELLO_SDCC)/ahello.hex,$(TEST_AHELLO_SDCC)/ahello.rel)

$(TEST_AHELLO_SDCC)/ahello.com: $(TEST_AHELLO_SDCC)/ahello.hex
	$(call mb_hex2com,$(TEST_AHELLO_SDCC)/ahello.hex,$(TEST_AHELLO_SDCC)/ahello.com)

.PHONY: test-ahello-sdcc-run
test-ahello-sdcc-run: $(TEST_AHELLO_SDCC)/ahello.com
	$(call mb_autoexec_open_gui,$(TEST_AHELLO_SDCC))
	$(call mb_openmsx_dos2,$(TEST_AHELLO_SDCC))

.PHONY: test-ahello-sdcc-assert
test-ahello-sdcc-assert: $(TEST_AHELLO_SDCC)/ahello.com
	$(call mb_delete,$(TEST_AHELLO_SDCC)/test.out)
	$(call mb_autoexec_cmd_test,$(TEST_AHELLO_SDCC),ahello > test.out)
	$(call mb_openmsx_dos2,$(TEST_AHELLO_SDCC))
	grep "SDCC: Hello world..." $(TEST_AHELLO_SDCC)/test.out
